/* $Id: param.h,v 1.3 1998/11/21 14:20:15 marcus Exp $
******************************************************************************

   KGIcon - System independent interface for subsystem-specific parameters

   Copyright (C) 1998	Marcus Sundberg		[marcus@ggi-project.org]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

typedef enum {
	KGI_SUBPARAM_INT,
	KGI_SUBPARAM_STRING
} kgi_subparam_t;

typedef struct kgi_subparam {
	int   handle;          /* The number used to refer to the parameter
				  (must be >= 1) */
	char *name;         /* The string name of the parameter */
	void *param;           /* A pointer to the actual parameter */
	int   size;            /* The size in bytes of the object pointed to */
	kgi_subparam_t type;   /* What kind of parameter it is */
	int   mode;            /* A standard Unix filemode describing who has
				  the right to read or write the parameter */
} kgi_subparam;


/* Monitor parameters */

enum {
	KGIMON_VMIN=1,
	KGIMON_VMAX,
	KGIMON_HMIN,
	KGIMON_HMAX,
	KGIMON_CMIN,
	KGIMON_CMAX,
	KGIMON_XRES,
	KGIMON_YRES,
};

extern kgi_subparam *kgim_monitor_get_params(void);
