/* 
 *  Extended copybox (supports drawing ops)
 *
 *  Copyright (C) 1999 Nicolai Haehnle
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "lib.h"
#include "ggi2dutil.h"

void	GGIEXP(copyBox)(struct ggi_visual *vis, ggi_sint x, ggi_sint y,
			ggi_sint w, ggi_sint h, ggi_sint nx, ggi_sint ny)
{
	void (*putPixel)(struct ggi_visual *vis, ggi_sint x, ggi_sint y, 
			ggi_pixel color);
	ggifunc_getpixel *getPixel;
	int tx, tnx, tw;

	CLIPCOPYBOX(vis,vis,x,y,nx,ny,w,h);
	
	putPixel = GGI2D_FUNC(vis)->putPixel;
	getPixel = vis->opdraw->getpixel;
	if (ny < y || ((ny == y) && (nx < x))) {
		for(; h; h--, y++, ny++) {
			for(tx = x, tnx = nx, tw = w; tw; tw--, tx++, tnx++) {
				ggi_pixel pixel;
				getPixel(vis, tx, y, &pixel);
				putPixel(vis, tnx, ny, pixel);
			}
		}
	} else if (ny > y) {
		y += h-1;
		ny += h-1;
		for(; h; h--, y--, ny--) {
			for(tx = x, tnx = nx, tw = w; tw; tw--, tx++, tnx++) {
				ggi_pixel pixel;
				getPixel(vis, tx, y, &pixel);
				putPixel(vis, tnx, ny, pixel);
			}
		}
	} else {
		for(; h; h--, y++, ny++) {
			for(tx = x+w-1, tnx = nx+w-1, tw = w; tw; 
					tw--, tx--, tnx--) {
				ggi_pixel pixel;
				getPixel(vis, tx, y, &pixel);
				putPixel(vis, tnx, ny, pixel);
			}
		}
	}
}
